function Watcher(){
    var watchValues = [];

    this.watch = function(gameObj, gameKey, interfaceObj, interfaceKey){
        watchValues.push({
            gameObj: gameObj,
            gameKey: gameKey,
            interfaceObj: interfaceObj,
            interfaceKey: interfaceKey,
            oldGameValue: gameObj.value(gameKey),
            oldInterfaceValue: interfaceObj[interfaceKey]
        });
    };

    this.sync = function(){
        watchValues.forEach(function(v){
            var newGameValue = v.gameObj.value(v.gameKey);
            var newInterfaceValue = v.interfaceObj[v.interfaceKey];
            var push = false;

            if(v.oldGameValue !== newGameValue){
                v.interfaceObj[v.interfaceKey] = newGameValue;
                push = true;
            }

            if(v.oldInterfaceValue !== newInterfaceValue){
                if(push)throw new Error('conflict');
                v.gameObj.setValue(v.gameKey, newInterfaceValue);
            }

            v.oldGameValue = newGameValue;
            v.oldInterfaceValue = newInterfaceValue;
        });
    }
}