<wrapper class={wrapper: true, show: showFlag, hide: !showFlag}>
    <div data-is="leftbox" next={next} onnext={performGoNext} onclose={hide}></div>
    <div data-is="rightbox" tws={tweets} onaction={refreshNext}></div>

    <div data-is="layer"></div>

    <script>
        function parseId(id){
            var parsed = /^(\d\d)_(\d\d)(\d\d)/.exec(id);
            if(parsed){
                return {
                    id: id,
                    sceneNumber: +parsed[1],
                    timeId: +(parsed[2] + parsed[3]),
                    timeString: parsed[2] + ':' + parsed[3]
                };
            }
        }

        function getSceneTweet(data, nameId, name, sceneNumber){
            var tweets = [];
            for(var n = 0, l = data.length; n < l; ++n){
                var t = data[n];
                var id = parseId(t[0]);
                if(id){
                    if(id.sceneNumber === sceneNumber){
                        tweets.push({
                            name: name,
                            name_id: nameId,
                            date: id.timeString,
                            id: id.id,
                            content: t[1],
                            msg: t[1].split('\n'),
                            rtSwitch: (t[2])?+t[2]: null,
                            likeSwitch: (t[3])?+t[3]: null,
                            showSwitch: (t[4])?+t[4]: null,
                            offSwitch: (t[5])?+t[5]: null
                        })
                    }
                }
            }

            return tweets;
        }

        function extractTweet(data, sceneNumber){
            var tweets = [];
            for(var name in data){
                if(data.hasOwnProperty(name)){
                    tweets = tweets.concat(getSceneTweet(data[name], data[name][0][2], name, sceneNumber));
                }
            }
            tweets = tweets.filter(function(tw){
                if(tw.showSwitch){
                    return $gameSwitches.value(tw.showSwitch);
                }
                if(tw.offSwitch){
                    return !$gameSwitches.value(tw.offSwitch);
                }
                return true;
            });
            tweets.sort(function(a, b){
                return a.timeId - b.timeId;
            });

            return tweets;
        }

        this.show = function(sceneNumber){
            this.tweets = extractTweet($dataTweet, sceneNumber);

            this.showFlag = true;
            this.root.style.zIndex = '20';
            Graphics._centerElement(this.root);
            this.suspendFlag = true;
            this.update();
        };

        this.hide = function(){
            this.showFlag = false;
            this.suspendFlag = false;
            this.update();
        }.bind(this);


        function checkNext(flags){
            return !flags.some(function(id){
                return !$gameSwitches.value(id);
            });
        }

        this.performGoNext = function(){
            if(checkNext(this.goNext)){
                this.hide();
            }
            this.update();
        }.bind(this);

        this.refreshNext = function(){
            this.next = checkNext(this.goNext);
        };

        this.listen('checkNext', function(){
            this.refreshNext();
        }.bind(this));


        //////////////////////////////////////////////
        //tkool commands
        //////////////////////////////////////////////
        var self = this;

        var SceneManager_updateScene = SceneManager.updateScene;
        SceneManager.updateScene = function(){
            if(!self.suspendFlag){
                SceneManager_updateScene.apply(this, arguments);
            }
        };
        
        var SceneManager_renderScene = SceneManager.renderScene;
        SceneManager.renderScene = function(){
            if(!self.suspendFlag){
                SceneManager_renderScene.apply(this, arguments);
            }
        };

        var Graphics_updateCanvas = Graphics._updateCanvas;
        Graphics._updateCanvas = function(){
            Graphics_updateCanvas.apply(this, arguments);
            self.root.style.zIndex = '20';
            Graphics._centerElement(self.root);
        };

        var Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
        Game_Interpreter.prototype.pluginCommand = function(cmd, args){
            switch(cmd){
                case 'tweet':
                    self.show(+args[0]);
                    break;

                case 'goNext':
                    self.goNext = args.map(function(d){return +d;});
                    self.update();
                    break;
            }

            return Game_Interpreter_pluginCommand.apply(this, arguments);
        };
    </script>
</wrapper>